/****************************************************************************
  FILE: JEx32.java, TomaszMajor-02Feb99
  PURPOSE: Tango tutorial example
****************************************************************************/


import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import webwisdom.tango.*;


public class JEx32 extends Applet implements ActionListener, TControlListener
{
    private static final String CL="JEx32";


    Button button;
    TAgent agent=null;


    public JEx32()
    {
      button=new Button("debug");
      setLayout(new BorderLayout());
      add("North",button);
      button.addActionListener(this);
    }// JEx ________________________________________________________________


    public void init()
    {
      try
      {
	agent=new TAgent(new TLAgentApplet(this));
	agent.addTControlListener(this);
      }
      catch(TangoException e)
      {
	e.printStackTrace();
      }
    }// init _______________________________________________________________


    public void destroy()
    {
      if(agent!=null)
	agent.exit();
    }// destroy ____________________________________________________________


    public void actionPerformed(ActionEvent evt)
    {
      if(evt.getSource()==button)
	if(agent!=null)
	{
	  System.out.println(CL+".actionPerformed(): agent="+agent);
	  System.out.println("\tuserName="+agent.getUserName());
	  System.out.println("\tmasterName="+agent.getMasterName());
	  System.out.println("\tisMaster="+agent.isMaster());
	  System.out.println("\tparticipantNames="+arrayToString(agent.getParticipantNames()));
	  System.out.println("\tisAudioAvailable="+agent.isAudioAvailable());
	}
    }// actionPerformed ____________________________________________________


    private static String arrayToString(Object[] ss)
    {
      StringBuffer s=new StringBuffer();
      s.append("{");
      for(int i=0;i<ss.length;i++)
      {
	s.append(ss[i].toString());
	if(i<(ss.length-1))
	  s.append(",");
      }
      s.append("}");
      return s.toString();
    }// arrayToString ______________________________________________________


    public void masterChanged(boolean isMaster,String masterName)
    {
      System.out.println(CL+".masterChanged("+isMaster+","+masterName+")");
    }// masterChanged ______________________________________________________


    public void participantJoined(String name)
    {
      System.out.println(CL+".participantJoined("+name+")");
    }// participantJoined __________________________________________________


    public void participantLeft(String name)
    {
      System.out.println(CL+".participantLeft("+name+")");
    }// participantLeft ____________________________________________________


    public void audioRequested(boolean r)
    {
      System.out.println(CL+".audioRequested("+r+")");
    }// audioRequested _____________________________________________________


}// JEx ////////////////////////////////////////////////////////////////////


